(defun c:sofa ()

; 	Este comando vai realizar um modelo de um sofá em 3D atendendo ao número de módulos e largura de cada módulo inseridos pelo utilizador, tendo
;	como standard uma base onde assenta com 10cm de altura, braços com 20cm de largura e 60cm de altura, costas com 20cm de espessura e 70cm de 
;	altura (desde a base) e módulos de assento com largura configuravél e uma profundidade fixa de 80cm. Há a possibilidade de inserir
;	no desenho do sofá uma chaise longue que assenta no módulo mais à esquerda ou no mais à direita. Para realização deste código houve consulta do
;	Autocad e também do chatgpt que foi usado para esclarecer melhor a syntax e a funcionalidade completa de algumas das funções.



(princ)

	(setq pontos2d (getvar "osmode"))			; Guarda as configurações do Osnap
	(setq pontos3d (getvar "3dosmode"))
	(princ)			; Mete uma linha limpa na linha de comandos do autocad, ajuda a que não haja overlapping de funções ou de texto ao realizar o comando


		(setq ponto (getpoint "Indique o ponto de inserção do sofá: "))			; Pede o ponto de inserção do sofá
			(princ)

		(If (= nil
		(setq n1 (getint "Indique o número de módulos <3>: ")))			; Pede o número de módulos que o utilizador que para o sofá
		(setq n1 3.00))
			(princ)

		(If (= nil
		(setq larguram (getreal "Indique a largura de cada módulo <0.70>: ")))
		(setq larguram 0.70))																; Configura a largura de cada módulo ou automaticamente define-o com 0.7 metros de largura
			(princ)

		(setq chaise (strcase (getstring t "Inserir uma chaise longue? [Sim/Não] ")))			; Pergunta se o utilizador quer inserir um chaise longue no modelo do sofá
		(cond 																					; Condição que determinar se se realiza o modelo da chaise longue
			((or (equal chaise "S") (equal chaise "SIM"))
			(setq lado (strcase (getstring t "Criar em que lado? [Esquerda/Direita] ")))		; Caso a resposta seja sim, o utilizador é perguntado de que lado do sofá que inserir o objeto
				(cond 																			; Condição para realizar a função determinada com a resposta anterior
					((or (equal lado "E") (equal lado "ESQUERDA"))
					(chaiseesq))

					((or (equal lado "D") (equal lado "DIREITA"))
					(chaisedir))
					(t (princ "Inválido")(princ))
				)
			)

			((or (equal chaise "N") (equal chaise "NAO"))
			(princ "Sem chaise longue")(princ))
			(t (princ "Inválido")(princ))			; Dá um output de texto na linha de comando caso seja inserido alguma respotas que não seja válida
		)


	(setvar "osmode" 0)			; Desliga o Osnap para evitar bugs ao fazer o modelo
	(setvar "3dosmode" 0)
  
		(modulo)

	(setvar "osmode" pontos2d)			; Volta a ligar o osnap com as definições retidas no início. É a última funcão para evitar desconfigurar o Osnap caso o comando seja cancelado a meio
	(setvar "3dosmode" pontos3d)
	(command "ucs" "")
	(princ)
)


		(defun modulo ()			; Desenha o modelo do sofá (sem a chasie longue)

			(command "ucs" ponto "")			; Configura a origem como o ponto de inserção

			(setq largura 0.80)			; configura a profundidade do sofá
			(setq altura 0.40)			; configura a altura do assento do sofá
			(command "box" (list 0 0 0) (list (+ (* larguram n1) 0.40) (+ largura 0.20) (+ 0.10)))			; Modela a base do sofá
			(setq base (entlast))			; Retem o objeto anterior com a variável "base"
			(command "box" (list 0.20 0.20 0.10) "l" larguram largura altura)			; Modela o assento do sofá
			(setq assento (entlast))			; Retem o objeto anterior com a variável "assento"
			(command "array" assento "" "r" 1 n1 larguram)			; Multiplica o assento com o rerspetivo número de módulos inseridos

			(setq espessurac 0.20)			; Define a espessura das costas
			(setq alturac 0.70)
			(command "box" (list 0.20 0 0.10) "l" larguram espessurac alturac)
			(setq costas (entlast))			; Retem o objeto anterior com a variável "costas"
			(command "array" costas "" "r" 1 n1 larguram)
			
			(command "box" (list 0 0 0.10) (list (+ 0.20) (+ largura 0.20) (- alturac 0.10)))			; Modela o braço direito

			(command "box" (list (+ (* larguram n1) 0.20) 0 0.10) (list (+ (* larguram n1) 0.4) (+ largura 0.20) (- alturac 0.10)))			; Modela o braço esquerdo

			(command "ucs" "")			; Repõe o UCS para World
		)


		(defun chaiseesq ()			; Desenha o modelo da chaise longue qaundo inserida à esquerda

			(command "ucs" ponto "")

			(command "box" (list (+ (* larguram (- n1 1)) 0.20) 1.00 0.10) "l" larguram 1.80 0.40)

			(command "ucs" "")

			(chaisebasee)

		)

			(defun chaisebasee ()			; Desenha o modelo da base chaise longue quando inserida à esquerda

				(command "ucs" ponto "")

				(command "box" (list (+ (* larguram (- n1 1)) 0.20) 1.00 0) "l" larguram 1.80 0.10)

				(command "ucs" "")

			)


		(defun chaisedir ()			; Desenha o modelo da chaise longue qaundo inserida à direita

			(command "ucs" ponto "")

			(command "box" (list 0.20 1.00 0.10) "l" larguram 0.80 0.40)

			(command "ucs" "")

			(chaisebased)

		)

			(defun chaisebased ()			; Desenha o modelo da base chaise longue qaundo inserida à direita

				(command "ucs" ponto "")

				(command "box" (list 0.20 1.00 0) "l" larguram 0.80 0.10)

				(command "ucs" "")

			)




